program test;

{$mode objfpc}{$H+}

uses
  sqlite3conn, sqldb;

var
  q: TSQLQuery;
  trans: TSQLTransaction;
  conn: TSQLConnector;
begin
  conn := TSQLConnector.Create(nil);
  trans := TSQLTransaction.Create(nil);
  q := TSQLQuery.Create(nil);
  try
    conn.ConnectorType := 'sqlite3';
    conn.DatabaseName := 'db.db3';
    conn.Open;
    trans.DataBase := conn;
    q.DataBase := conn;
    q.Transaction := trans;
    trans.StartTransaction;
    try
      q.SQL.Text := 'select id, name from person order by id';
      q.Open;
      while not q.EOF do
      begin
        WriteLn('ID: ', q.Fields.FieldByName('id').AsInteger, ' Name: ',
          q.Fields.FieldByName('name').AsString);
        q.Next;
      end;
      trans.Commit;
    except
      trans.Rollback;
      raise;
    end;
  finally
    q.Free;
    trans.Free;
    conn.Free;
  end;
end.

